#include <stdio.h>
#include "config_sio.h"
#include "config_clock_flash.h"
#include "config_time.h"
#include "config_port.h"
#include "config_PWM.h"
#include "config_encoder.h"
#include "config_autoADC.h"
#include "module_test.h"

extern "C" { extern void startup(); }

int main(void)
{
	// スタートアップルーチン
	startup();

	// クロックとFLASHの設定
	CLOCK_FLASH_config();
	// シリアル通信の設定
	USART_DMA_config_for_SIO();

	// 普通の入出力ポートの設定
	GPIO_config();
	// PWM出力の設定
	TIM_config_for_PWM_motor();
	// エンコーダ入力の設定
	TIM_config_for_encoder1();
	TIM_config_for_encoder2();
	// 周期割り込み付き自動AD変換設定
	ADC_TIM_DMA_config_for_autoADC();

	// 少し待つ（0.5秒）
	wait(0.5);

	extern const char date_str[], time_str[];
	printf("---- Compiled @ %s %s ----\r\n",date_str,time_str);

	module_test_low_level();

	while(1){
		printf("Hello world!\r\n");
		wait(0.5);
	}
	
	return 0;
}

